This repository is for the OZG-Cloud Fachstellenbeteiligung.

# Getting Started

### Reference Documentation

For further reference, please consider the following sections:

* [Create an OCI image](https://docs.spring.io/spring-boot/docs/3.1.3/maven-plugin/reference/html/#build-image)
* [Spring Boot Actuator](https://docs.spring.io/spring-boot/docs/3.1.3/reference/htmlsingle/index.html#actuator)
* [Spring Boot MVC](https://spring.io/guides/gs/serving-web-content)
* [Spring Boot DevTools](https://docs.spring.io/spring-boot/docs/3.1.3/reference/htmlsingle/index.html#using.devtools)
* [WebJars](https://www.webjars.org/)
* [Bootstap](https://getbootstrap.com/docs/5.3/getting-started/introduction/)

### SAML ID

To test the application the [mujina saml idp](https://github.com/OpenConext/Mujina) is used.
To start the IDP see the docker compose file in src/docker

The IDP will create a user on the fly when you log in.
If you need to set additional attributes and users you can use curl.

To add a user use

```shell
curl -v -H "Accept: application/json" \
        -H "Content-type: application/json" \
        -X PUT -d '{"name": "bob", "password": "s3cr2t", "authorities": ["ROLE_USER", "ROLE_ADMIN"]}' \
        http://localhost:8088/api/users
```

this will add the user 'bob' with the password 's3cr3t'.

To add additional attributes to the user use

```shell
curl -v -H "Accept: application/json" \
        -H "Content-type: application/json" \
        -X PUT -d '["NameId"]' \
        http://localhost:8088/api/attributes/atrribute-xyz/bob
```

This will set the attribute 'attribute-xyz' with the value 'NameId' to the user 'bob'.


